﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Private mTarget As Object
    Private mEventName As String
    Public baseC As Panel
    Dim cvs As Canvas
	Dim rv As RippleView
	Dim cLabel As Label
End Sub

'Initializes the Object. You can add parameters To this method If needed.
Public Sub Initialize(Module As Object, EventName As String)


End Sub

Public Sub DesignerCreateView(base As Panel, lbl As Label, Props As Map)
baseC = base
cLabel.Initialize("cLabel")
base.Height = base.width             'make it square if not already
cLabel.Text = lbl.text
cLabel.textColor = lbl.textColor
cLabel.TextSize = lbl.textsize
cLabel.Gravity= Bit.OR(Gravity.CENTER, Gravity.CENTER_HORIZONTAL)

base.AddView(cLabel, 0, 0, base.Width, base.Height)

Dim clr As Int = GetViewsColor(base) 'gets the color of the base view set in the designer
Dim dr As ColorDrawable              'used to set the corner radius to 50% of width/height (makes it round)
dr.Initialize(clr, 50%x)             'sets color as per designer and set corner radius.. use buttColor prop to reset color if required              						 
base.background = dr                 'set base backgroung as well
rv.Initialize(cLabel, Colors.Red, 200, True) 'adds rippleEffect
End Sub
Sub GetViewsColor(v As View) As Int     'used to get the color set in the designer
Dim bmp As Bitmap
bmp.InitializeMutable(50dip, 50dip)
cvs.Initialize2(bmp)
Dim destRect As Rect
destRect.Initialize(0, 0, cvs.Bitmap.Width, cvs.Bitmap.Height)
cvs.DrawDrawable(v.Background, destRect)
Return cvs.Bitmap.GetPixel(5dip, 5dip)
End Sub


Private Sub cLabel_Click 'handles click event
If mTarget <> "" AND mEventName <> "" Then
CallSubDelayed(mTarget,mEventName)    'target and event name set in sub rEvent
End If
End Sub
Public Sub rEvent(e As String, m As Object) 'must set this in activity_create for events to work
mEventName = e
mTarget = m
End Sub

Sub rippleColor(rc As Int)
rv.Ripple(True, rc, 150, True, 1)
End Sub
Sub textColor(t As Int)
cLabel.TextColor = t
End Sub
Sub backColor(bt As Int)
baseC.Color = bt
End Sub
Sub newText(st As String)
cLabel.Text = st
End Sub
Sub newTextSize(ts As Int)
cLabel.TextSize = ts
End Sub